<?php
class WRS_CMS_Bridge {

    var $headings = array();
    var $levels = array();
    var $urls = array();


    function WRS_CMS_Bridge(){
        global $h, $l, $u;
        $this->headings = $h;
        $this->levels = $l;

        $this->urls = $u;
    }

    function getHeadings($level = 0){
        if($level > 0){
            $array = array();
            foreach($this->headings as $key => $heading){
                if($this->levels[$key] <= $level){
                    $array[$key] = $heading;
                }
            }
            return $array;
        }
        return $this->headings;
    }

    function getHeadingOfUrl($url = '- nope -'){
        if(array_search($url, $this->urls) === false){
            trigger_error('WRS_CMSimple_Bridge::getHeadingOfUrl($url) - ' . $url . ' does not exist.');
        }
        return $this->headings[array_search($url, $this->urls)];
    }

    function getUrls($level = 0){
        if($level > 0){
            $array = array();
            foreach($this->urls as $key => $link){
                if($this->levels[$key] <= $level){
                    $array[$key] = $link;
                }
            }
            return $array;
        }
        return $this->urls;
    }

    function getLevelOfUrl($url){
        if(array_search($url, $this->urls) === false){
            trigger_error('WRS_CMSimple_Bridge::getLevelOfUrl($url) - ' . $url . ' does not exist.');
        }
        return $this->levels[array_search($url, $this->urls)];
    }


    function pageExists($link = ''){
        return in_array($link, $this->urls);
    }

    function translateStringToUrl($string = ''){
        return '?' . uenc($string);
    }

    function translateUrl($url){
        return '?' . $url;
    }

    function getLevels($level = 0){
        if($level > 0){
            $array = array();
            foreach($this->levels as $mylevel){
                if($myLevel <= $level){
                    $array[$key] = $myLevel;
                }
            }
            return $array;
        }
        return $this->levels;
    }

    function addToHeader($string){
        global $hjs;
        $hjs .= $string;
    }

    function shopSubpages($level = 6){
        $pages = array();
        $index    = array_search(WRS_URL, $this->urls);
        $shopLevel    = $this->levels[$index];
        $index++;
        $i = 0;
        while($index < count($this->urls) && $this->levels[$index] > $shopLevel){
            if($this->levels[$index] > $level){
                $index++;
                continue;
            }
            $pages[$i]['url'] = '?' . $this->urls[$index];
            $pages[$i]['heading'] = $this->headings[$index];
            $pages[$i]['level'] = $this->levels[$index];
            $index++;
            $i++;

        }
        return $pages;
    }

    function initProductDescriptionEditor(){
        global $pth, $cf, $hjs, $onload, $sn, $sl;

        if($cf['editor']['external']=="tinymce")
        {
            if(!key_exists('tinymce', $cf) ||$cf['tinymce']['folder'] == '') {
                $cf['tinymce']['folder']='tiny_mce';
            }
            if(is_dir($pth['folder']['base'].$cf['tinymce']['folder'])){
                $description_editor = "TinyMCE";
                $hjs .= '<script language="javascript" type="text/javascript" src="'.$pth['folder']['base'].$cf['tinymce']['folder'].'/tiny_mce.js"></script>
                <script language="javascript" type="text/javascript">
                tinyMCE.init({
                    plugins : "table,advimage,advlink,media,contextmenu,",
                    mode: "textareas",
                    theme: "advanced",
                    width: "100%",
                    language: "'.$sl.'",
                    content_css: "'.$sn.'?&stylesheet",
                    theme_advanced_toolbar_location : "top",
                    theme_advanced_statusbar_location : "bottom",
                    theme_advanced_resizing : true,
                    theme_advanced_toolbar_align : "left",
                    theme_advanced_buttons1 : "bold,italic,|,bullist,numlist,|,charmap,|,indent,outdent,|,link,unlink,|,undo,redo,|,help,code,",
                    theme_advanced_buttons2 : "",
                    theme_advanced_buttons3 : ""});
                </script>
                ';

            }

        }
        if($cf['editor']['external']=="fckeditor")
        {
            if(!key_exists('fckeditor', $cf) ||$cf['fckeditor']['folder']== '') {
                $cf['fckeditor']['folder']='FCKeditor';
            }
            if(@is_dir($pth['folder']['base'].$cf['tinymce']['folder'])){
                $onload .= ' onload="init_simpleFCK()"';
                $hjs .= '
                <script language="javascript" type="text/javascript" src="'.$pth['folder']['base'].$cf['fckeditor']['folder'].'/fckeditor.js"></script>
                <script language="javascript" type="text/javascript">

                function init_simpleFCK(){
                    var sBasePath = "'.$pth['folder']['base'].$cf['fckeditor']['folder'].'/" ;
                    var simpleFCK = new FCKeditor("wrsDescription","100%",200) ;
                    simpleFCK.BasePath = sBasePath;
                    simpleFCK.Config["ToolbarCanCollapse"] = false;
                    simpleFCK.ToolbarSet = "Basic" ;
                    simpleFCK.ReplaceTextarea() ;
                }
                function FCKeditor_OnComplete( simpleFCK )
                {
                     simpleFCK.Config["ToolbarSets"]["Minimalistic"] = [
                            ["Source", "Bold", "Italic", "OrderedList", "UnorderedList", "Undo", "Redo", "Link", "Unlink"]
                        ] ;
                    simpleFCK.EditorWindow.parent.FCK.ToolbarSet.Load( "Minimalistic" ) ;
                }
                </script>
                ';
            }

        }
    }

        function getCurrentPage(){
            $url = explode('&', $_SERVER['QUERY_STRING']);

            return $url[0];

        }
    }
    ?>