<?php
global $wrsController;

class WRS_Paypal extends WRS_Payment_Module {
    var $currency_codes = array('AUD' => 'Australian Dollar',
                                'CAD' => 'Canadian Dollar',
                                'EUR' => 'Euros',
                                'GBP' => 'Pound Sterling',
                                'JPY' => 'Yen',
                                'USD' => 'U.S. Dollar',
                                'NZD' => 'New Zealand Dollar',
                                'CHF' => 'Swiss Franc',
                                'HKD' => 'Honkong Dollar',
                                'SGD' => 'Singapore Dollar',
                                'SEK' => 'Swedish Krona',
                                'DKK' => 'Danish Krone',
                                'PLN' => 'Polish Zloty',
                                'NOK' => 'Norwegian Krone',
                                'HUF' => 'Hungarian Forint',
                                'CZK' => 'Czech Koruna',
                                'ILS' => 'Israeli Shekel',
                                'MXN' => 'Mexican Peso',
                                'PHP' => 'Philippine Pesos',
                                'TWD' => 'Taiwan New Dollars',
                                'THB' => 'Thai Baht',
                                'BRL' => 'Brazilian Real (only for Brazilian users)',
                                'MYR' => 'Malaysian Ringgits (only for Malaysian users)'
    );
    var $name = 'paypal';
    var $requiredData = array('business'      => null,        // e-mail adress
                              'currency_code' => null,        // EUR, USD ...
                              'lc'            => null         // language code (EN, DE, ...)
    );
    function WRS_Paypal(){

        $this->loadLanguage();
        $this->loadSettings();


    }
    function isAvailable(){
        return strlen(trim($this->settings['currency_code'])) === 3 && strlen(trim($this->settings['business'])) > 5;
    }

    function wantsCartItems(){
        return true;
    }

    function getLabel(){
        return '<img src="' . WRS_BASE_PATH . 'classes/paymentmodules/paypal/images/paypal_solutions.gif">
';
    }

    function orderSubmitForm(){
       
        
        $form = '
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
    <input type="hidden" name="cmd" value="_cart" />
	<input type="hidden" name="upload" value="1" />
	<input type="hidden" name="business" value="'. $this->settings['business'] . '">
	<input type="hidden" name="currency_code" value="' . $this->settings['currency_code'] . '" />
    <input type="hidden" name="lc" value="' . strtoupper(WRS_LANGUAGE) . '" />
	<input type="hidden" name="rm" value="2" />
    <input type="hidden" name="custom" value="thankYou" />
	<input type="hidden" name="handling_cart" value="'. ($this->settings['fee'] + $this->shipping) .'" />
    <input type="hidden" name="cancel_return" value="' . $_SERVER['HTTP_REFERER'] . '" />
	<input type="hidden" name="return" value="' . $_SERVER['HTTP_REFERER'] . '" />';

     foreach($this->cartItems as $item){
            $name = strip_tags($item['name']);
            $name .= isset($item['variantName']) ? ', '. $item['variantName'] : '';
            $form .= '
     <input type="hidden" name="item_name_' . $item['itemCounter'] .'" value="' . $name . '" />
     <input type="hidden" name="quantity_' . $item['itemCounter'] .'" value="' . $item['amount'] . '" />
     <input type="hidden" name="amount_' . $item['itemCounter'] .'" value="' . sprintf('%.2f', $item['price']) . '" />
     <input type="hidden" name="item_number_' . $item['itemCounter'] .'" value="' . $item['itemCounter'] . '" />';
        }
        $form .= '
     <input type="submit" value="' . $this->language['go_to_paypal'] .'" class="shopButton" />
</form>
';

        return $form;
    }

    function settingInputs(){
        $test = $this->shopCurrency;
        if($test == '$'){$test = 'USD';}
       if(in_array($test, array('&euro;' , '€', '&#x20AC;', '&#8364;'))){$test = 'EUR';}
       if(in_array($test, array('&pound;', '£' , '&#163;', '&#x00A3;'))){$test = 'GBP';}
       if(in_array($test, array('&yen;', '¥' , '&#165;', '&#x00A5;'))){$test = 'JPY';}

        
       $currency = strlen($this->settings['currency_code']) === 3 ? $this->settings['currency_code'] : 'none';
       
       $html = '<p><label>';
       $html .= $this->language['business'] . ':<br />';
       $value = isset($this->settings['business']) ? $this->settings['business'] : '' ;
       
       $html .= '<input type="text" size="40" name="ppBusiness" value="' . $value . '" />';
       $html .= '</label></p><p>';
       if($test !== $currency && key_exists($test, $this->currency_codes)){

            $chosen = key_exists($currency, $this->currency_codes) ? $this->currency_codes[$currency] : '???';
            $html .= '<b>' . $this->language['currency_warning']. ':</b> Shop: '.  $this->currency_codes[$test] . '(?) - Paypal: ' . $chosen .')<br />';
            $currency = $test;
        }
       $html .= $this->language['currency_code'] . '<br /><select name="ppCurrencyCode">';
       $html .= '<option value="">Select Currency</option>';
       
       foreach($this->currency_codes as $code => $value){
           $selected = $code == $currency ? ' selected="selected"' : '';
           $html .= '<option value="' . $code .  '"' . $selected . '>' . $value . '</option>';
       }
       $html .= '</select></p>';

      return $html;
    }
    function saveConfig(){
        
        if(isset($_POST['ppCurrencyCode'])){
            $this->settings['currency_code'] = '' . $_POST['ppCurrencyCode'] . '';
        }

        if(isset($_POST['ppBusiness'])){
            $business = trim($_POST['ppBusiness']);
            if(get_magic_quotes_gpc()===1){$business = stripslashes($business);}
            $this->settings['business'] = '' .  $business  . '';
        }
        $file = WRS_BASE_PATH . 'classes/paymentmodules/' . $this->name . '/settings.php';
        $handle = fopen($file, 'w');
        if(!$handle){
            return false;
        }
        $string = '<?php' . "\n";
        foreach($this->settings as $key => $value){
            if(is_string($value)){$value = '"' . $value . '"';}
            $string .=  '$config[\'' . $key .'\'] = '.  $value . ';' . "\n";
        }
        $string .= '?>';
        fwrite($handle, $string);
        fclose($handle);
        return true;
    }
}
$wrsPaypal = new WRS_Paypal();
$wrsController->addPaymentModule($wrsPaypal);
?>
