<h5><?php $this->label('checkout_overview'); ?></h5>
<div id="steps">
    <span>1. <?php $this->label('checkout_step1'); ?></span>
    <span>2. <?php $this->label('checkout_step2'); ?></span>
    <span class="now">3. <?php $this->label('checkout_step3'); ?></span>
</div>
<p>
    <?php $this->hint('final_confirmation'); ?>
</p>
<fieldset><legend><?php $this->label('summary'); ?></legend>
    <table>
        <tr>
            <td><?php $this->label('date_of_order') ; ?>:&nbsp;&nbsp;</td>
            <td><?php echo date('d. M. Y'); ?></td>
        </tr>
        <tr>
            <td style="vertical-align: top;" ><?php echo $this->label('delivery_adress'); ?>:&nbsp;&nbsp;</td>
            <td>%FIRST_NAME% %LAST_NAME%<br />
                %STREET%<br />
                %ZIP_CODE% %CITY%<br />
                %COUNTRY%<br />
                %EMAIL%<br />
                %PHONE%
            </td>
        </tr>
        <tr>
            <td><?php $this->label('payment_mode') ?>:&nbsp;&nbsp;</td>
            <td><?php echo $this->payment->getLabelString(); ?></td>
        </tr>
        <tr>
            <td><?php $this->label('annotation') ?>:&nbsp;&nbsp;</td>
            <td>%ANNOTATION%</td>
        </tr>
    </table>
    <table class="cart" width="100%" border ="0" rules="all" cellspacing="0px" cellpadding="0px">
        <?php foreach($this->cartItems as $product){
            $rowCounter = $product['itemCounter']; ?>
        <tr class="<?php echo $this->oddOrEven($rowCounter); ?>">
            <td style="text-align: right;"><?php echo $product['amount'] ;?> x &nbsp; </td>
            <td> <?php echo $product['name'];?> <?php echo $product['variantName']; ?></td>
            <td style ="text-align: right; white-space: nowrap;padding-right: 1em;"> &agrave;
                <?php echo $this->formatCurrency($product['price']) ;?>
            </td>
            <td style ="text-align: right; white-space: nowrap;">
                <?php echo $this->formatCurrency($product['sum']) ;?>
            </td>
        </tr>
        <?php
    }
    $rowCounter++;
    ?>
        <tr class= "<?php echo $this->oddOrEven($rowCounter); ?>">
            <td></td>
            <td colspan="2"><b><?php $this->label('subtotal'); ?></b></td>
            <td style ="text-align: right; font-weight: bold; white-space: nowrap;">
                <?php echo $this->formatCurrency($this->cartSum); ?>
            </td>
        </tr>
        <?php $rowCounter++; ?>
        <tr class= "<?php echo $this->oddOrEven($rowCounter); ?>">
            <td></td>
            <td colspan="2"><b><?php $this->label('forwarding_expenses'); ?></b></td>
            <td style ="text-align: right; font-weight: bold; white-space: nowrap;">
                <?php echo $this->formatCurrency($this->shipping); ?>
            </td>
        </tr>
        <?php
        $rowCounter++;
        if($this->fee < 0){
            $feeLabel = $this->labels['reduction'];
        }
        else{
            $feeLabel = $this->labels['fee'];
        }
        ?>
        <tr class= "<?php echo $this->oddOrEven($rowCounter); ?>">
            <td></td>
            <td colspan="2"><b><?php echo $feeLabel; ?></b></td>
            <td style ="text-align: right; font-weight: bold; white-space: nowrap;">
                <?php echo $this->formatCurrency($this->fee); ?>
            </td>
        </tr>
        <?php $rowCounter++; ?>
        <tr class= "<?php echo $this->oddOrEven($rowCounter); ?>">
            <td></td>
            <td colspan="2"><b><?php $this->label('total'); ?></b></td>
            <td style ="text-align: right; font-weight: bold; white-space: nowrap;">
                <?php echo $this->formatCurrency($this->total); ?>
            </td>
        </tr>

    </table>
    <?php if($this->hideVat === false){ ?>
    <p>
        <?php echo $this->label('included_vat') . ' ' . $this->formatCurrency($this->vatTotal) ; ?>
        (<?php echo $this->formatFloat($this->reducedRate); ?>%: <?php echo $this->formatCurrency($this->vatReduced); ?>
        - <?php echo $this->formatFloat($this->fullRate); ?>%: <?php echo $this->formatCurrency($this->vatFull); ?>)
    </p>
    <?php }; ?>
</fieldset>

<table style="width: 100%; margin-top: 1em;">
    <tr>

        <td>
            <form action="" method="post" style="display: inline;">
                <input type="hidden" name="wrsCheckout" value="customersData" />
                <input type="submit" class="shopButton"  value="<?php $this->label('previous'); ?>" />
            </form>
        </td>
        <td style = "text-align: right;" >
            <?php
            if($this->payment->orderSubmitForm() === false){
                ?>
            <form action="" method="post" style="display: inline;">
                <input type="hidden" name="wrsCheckout" value="finish" />
                <input type="submit" class="shopButton"  value="<?php $this->label('send_order'); ?>" />
            </form>
            <?php
        }else{
            echo $this->payment->orderSubmitForm();
        }
        ?>

        </td>
    </tr>
</table>
